package com.iformall.service;

import java.util.*;
import com.github.pagehelper.PageInfo;
import com.iformall.common.ResultData;
import com.iformall.domain.po.MallUserInfo;
import com.iformall.domain.po.WxBillRent;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author gongbiao
 */
public interface WxBillRentService {

    /**
     * 根据实体查询列表
     * @param record
     * @param pageIndex
     * @param pageSize
     * @return
     */
    PageInfo<WxBillRent> listAsPage(WxBillRent record, Integer pageIndex, Integer pageSize);

    void updateBillStatus(WxBillRent record);

    /**
     * 根据Id获得实体
     *
     * @param id
     * @return
     */
    WxBillRent getById(Long id);
    
    /**
     * 保存或更新实体
     *
     * @param record
     * @param user
     */
    ResultData saveOrUpdate(WxBillRent record, MallUserInfo user);

    /**
     * 修改滞纳金
     * @param record
     * @param user
     * @return
     */
    ResultData updateLatePayMoney(WxBillRent record, MallUserInfo user);

    /**
     * 根据Id删除实体
     *
     * @param id
     */
    void deleteById(Long id);


    PageInfo<WxBillRent> findByRentContractId(Long id, String tenantId, Integer pageIndex, Integer pageSize);

    ResultData updatePaid(Long id);

    Object detail(Long id);

    ResultData updateRevenue(WxBillRent wxBillRent, MallUserInfo user);


    ResultData updateLatePayStatus(WxBillRent wxBillRent);

    void exportBill(HttpServletRequest request, HttpServletResponse response, WxBillRent wxBillRent);
}
